<?php
/**
*
* @package - GeoMap
* @version $Id: geomap.php 25 2009-02-07 14:40:21Z Frank Wiesemann $
* @copyright (c) Frank Wiesemann ( http://webmasterarena.net/ )
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @package phpBB3
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

include($phpbb_root_path.'common.'.$phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/functions_geomap.' . $phpEx);
include($phpbb_root_path . 'includes/functions_user.' . $phpEx);

$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/geomap');
$geomap = new geomap();

// grab post vars
$ajax_plz		= request_var('ajax_plz_id', '0');
$ajax_land		= request_var('ajax_land_id', 0);
$has_found = false;
$position = array();
$tmp_events = '';

if ($ajax_plz != 0 && $ajax_land != 0 && $geomap->is_plz_string($ajax_plz))
{
	$position = $geomap->getPostcodePosition($ajax_plz, $ajax_land);

	if (!empty($position))
	{
		// get users in radius
		$geo_user_search_ary = $geomap->searchGeoUser($position['lenght'], $position['width'], 0);
		if (!empty($geo_user_search_ary)) $has_found = true;
	}
}

$tmp_row = "<table style=\"width:100%\">\n";
$tmp_row .= "\t<tr><th>" . $user->lang['USERNAME'] . "</th><th>" . $user->lang['POSTCODE'] . "</th><th>" . $user->lang['TOWN'] . "</th></tr>\n";
if ($has_found)
{
	foreach($geo_user_search_ary as $value)
	{
		// Select some userdata from DB
		$sql = 'SELECT username, username_clean, user_colour
			FROM ' . USERS_TABLE . '
			WHERE user_id = '. (int) $value['user_id'];
		$result = $db->sql_query($sql);
		if($row = $db->sql_fetchrow($result))
		{
			// Get username with usercolor
			$username = get_username_string('full', $value['user_id'], $row['username'], $row['user_colour'], $row['username_clean']);
		}
		$value['user_id'] = ($username) ? $username : $value['user_id'];
		$tmp_row .= "\t<tr><td>$value[user_id]</td><td>" . $value['pf_plz'] . "</td><td>$value[user_from]</td></tr>\n";
	}
}
else
{
	$tmp_row .= "\t<tr><td colspan=\"2\">" . $user->lang['NO_GEO_USERS'] . "</td></tr>\n";
}

$tmp_row .= "</table>";

// events
if (!empty($position))
{
	$tmp_events = '';
	$geo_events = $geomap->getGeoEvents($position['lenght'], $position['width']);
	if (!empty($geo_events))
	{
		$tmp_events = "<table style=\"width:100%\">\n<tr><th>" . $user->lang['GEO_EVENT'] . "</th><th>" . $user->lang['GEO_DESC'] . "</th><th>" . $user->lang['TOWN'] . "</th></tr>\n";
		foreach ($geo_events as $geo_event)
		{
			$tmp_events .= "\t<tr><td>$geo_event[event_name]</td><td>" . $geo_event['event_desc'] . "</td><td>" . $geo_event['event_plz'] . "\n" . $geo_event['event_ort'] . "</td></tr>\n";
		}
		$tmp_events .= "</table>";
		if (!$has_found) $tmp_row = '';
	}
}

// Send XML File
header('Content-Type: text/xml; charset=utf-8');
echo '<' . '?xml version="1.0" encoding="UTF-8"?' . '>' . "\n";
echo '<geomapdata><![CDATA[' . $tmp_events . $tmp_row . ']]></geomapdata>' . "\n";
?>