<?php
/**
*
* @package - GeoMap
* @version $Id: geomap.php 25 2009-02-07 14:40:21Z Frank Wiesemann $
* @copyright (c) Frank Wiesemann ( http://webmasterarena.net/ )
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @package acp
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class acp_geomap
{
	var $u_action;

	function main($id, $mode)
	{
		global $db, $user, $template, $config, $phpbb_root_path, $phpEx, $phpbb_admin_path;

		include($phpbb_root_path . 'includes/functions_geomap.' . $phpEx);
		$geomap = new geomap();

		$this->tpl_name = 'acp_geomap';
		$action = request_var('action', '');
		
		$form_key = 'acp_geomap';
		add_form_key($form_key);

		switch ($mode)
		{
			case 'settings':
				$this->page_title = 'ACP_GEO_SETTINGS';

				if ($action == 'set')
				{
					if (!check_form_key($form_key))
					{
						trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
					}

					// check color insert, if invalid set to default
					$user_color = str_replace('#', '', request_var('user_color', ''));
					if(!preg_match("/^(([a-f]|\d){3}|([a-f]|\d){6})$/i", $user_color)) $user_color = '0000FF';
					
					$event_color = str_replace('#', '', request_var('event_color', ''));
					if(!preg_match("/^(([a-f]|\d){3}|([a-f]|\d){6})$/i", $event_color)) $event_color = 'FFFF00';

					// check pixelsize, if to small, set to minimum size
					$admin_pixel	= (request_var('admin_pixel', 8) < 6 ? 6 : request_var('admin_pixel', 8));
					$mod_pixel		= (request_var('mod_pixel', 8) < 6 ? 6 : request_var('mod_pixel', 8));
					$user_pixel		= (request_var('user_pixel', 8) < 6 ? 6 : request_var('user_pixel', 8));
					$event_pixel	= (request_var('event_pixel', 12) < 6 ? 6 : request_var('event_pixel', 12));

					$sql_ary = array(
						'user_color'		=> $user_color,
						'admin_pixel'		=> $admin_pixel,
						'mod_pixel'			=> $mod_pixel,
						'user_pixel'		=> $user_pixel,
						'event_pixel'		=> $event_pixel,
						'event_color'		=> $event_color,
						'inactive_text'		=> utf8_normalize_nfc(request_var('inactive_text', '', true)),
						'active'			=> request_var('is_active', 0),
						'refresh_interval'	=> request_var('refresh_interval', 0),
						'show_events'		=> request_var('show_events', 0),
						
					);
					$db->sql_query('UPDATE ' . GEOMAP_CONFIG_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary));

					$db->sql_query('UPDATE ' . PROFILE_FIELDS_TABLE . ' SET field_required = ' . request_var('require', 0) . "
						WHERE field_name = 'plz' OR field_name = 'land'"
					);

					trigger_error($user->lang['UPDATED'] . adm_back_link($this->u_action));
				}

				$template->assign_vars(array(
					'USER_COLOR'			=> strtoupper($geomap->geoconfig['user_color']),
					'EVENT_COLOR'			=> strtoupper($geomap->geoconfig['event_color']),
					'ADMIN_PIXEL'			=> $geomap->geoconfig['admin_pixel'],
					'MOD_PIXEL'				=> $geomap->geoconfig['mod_pixel'],
					'USER_PIXEL'			=> $geomap->geoconfig['user_pixel'],
					'EVENT_PIXEL'			=> $geomap->geoconfig['event_pixel'],
					'U_SWATCH'				=> append_sid("{$phpbb_admin_path}swatch.$phpEx", 'form=geo_settings&amp;name=user_color'),
					'U_SWATCH_E'			=> append_sid("{$phpbb_admin_path}swatch.$phpEx", 'form=geo_settings&amp;name=event_color'),
					'MAP_STATUS'			=> ($geomap->geoconfig['active'] == 1 ? 'checked="checked"' : ''),
					'INACTIVE_TEXT_VALUE'	=> $geomap->geoconfig['inactive_text'],
					'REFRESH_INTERVAL'		=> $geomap->geoconfig['refresh_interval'],
					'U_ACTION'				=> $this->u_action . '&amp;action=set',
					'TITLE'					=> $user->lang['ACP_GEO_SETTINGS'],
					'TITLE_DESC'			=> $user->lang['ACP_GEO_SETTINGS_DESC'],
					'GEOMAP_VERSION'		=> $user->lang['ACP_GEOMAP'] .= ' v.' . $config['geomap_mod_version'],
					'EVENT_STATUS'			=> ($geomap->geoconfig['show_events'] == 1 ? 'checked="checked"' : ''),
				));

				// get profile field require option
				$sql = 'SELECT field_required FROM ' . PROFILE_FIELDS_TABLE . "
					WHERE field_name = 'plz'";
				$result = $db->sql_query($sql);

				$template->assign_vars(array(
					'REQUIRE_VALUE'			=> ($db->sql_fetchfield('field_required') == 1 ? 'checked="checked"' : ''),
				));
				$db->sql_freeresult($result);
			break;

			case 'group_management':
				$this->page_title = 'ACP_GEO_GRPMGMT';

				$grp_upd = request_var('grp_upd', false);
				if ($grp_upd)
				{
					$group_id = request_var('grp_id', 0);

					$result = $db->sql_query('SELECT geo_hide FROM ' . GROUPS_TABLE . '
							WHERE group_id = ' . $group_id);

					$hide_value = ($db->sql_fetchfield('geo_hide') == 0 ? 1 : 0);
					$db->sql_freeresult($result);

					$db->sql_query('UPDATE ' . GROUPS_TABLE . '
						SET geo_hide = ' . $hide_value . '
						WHERE group_id = ' . $group_id);
				}
				$geogroups = $geomap->getGeoGroups(true);

				foreach($geogroups as $geogroup)
				{
					$template->assign_block_vars('groups_in_map', array(
						'GROUP_NAME'	=> $geogroup['group_name'],
						'GROUP_COLOUR'	=> $geogroup['group_colour'],
						'GROUP_HIDE'	=> ($geogroup['geo_hide']) ? true : false,
						'DE_ACTIVATE'	=> $this->u_action . '&amp;grp_upd=1&amp;grp_id=' . $geogroup['group_id'],
					));
				}

				$template->assign_vars(array(
					'TITLE'				=> $user->lang['ACP_GEO_GRPMGMT'],
					'TITLE_DESC'		=> $user->lang['ACP_GEO_GRPMGMT_DESC'],
					'U_GRP_MGMT'		=> true,
				));
			break;

			case 'events':
				$this->page_title = 'ACP_GEO_EVENTMGMT';

				switch ($action)
				{
					case 'event_add':
						$land_option_ary = $geomap->getLandOptions();

						foreach($land_option_ary as $land_id => $land_name)
						{
							$template->assign_block_vars('land_switch', array(
								'LAND_ID'	=> $land_id,
								'LAND_NAME'	=> $land_name,
							));
						}

						$start_day = date('d', time());
						$start_month = date('n', time());
						$start_year = date('Y', time());
						$end_day = date('d', time() + 86400);
						$end_month = date('n', time() + 86400);
						$end_year = date('Y', time() + 86400);

						$template->assign_vars(array(
							'POST_START_DAY'	=> $this->option_list(1, 31, $start_day),
							'POST_START_MONTH'	=> $this->option_list(1, 12, $start_month),
							'POST_START_YEAR'	=> $this->option_list(2008, 2020, $start_year),
							'POST_END_DAY'		=> $this->option_list(1, 31, $end_day),
							'POST_END_MONTH'	=> $this->option_list(1, 12, $end_month),
							'POST_END_YEAR'		=> $this->option_list(2008, 2020, $end_year),
							'S_EVENT_AKTIV'		=> true,
							'TITLE'				=> $user->lang['ACP_GEO_EVENTMGMT'],
							'U_EVENT_EDIT'		=> true,
							'U_BACK'			=> $this->u_action,
							'U_ACTION'			=> $this->u_action . '&amp;action=event_insert',
						));
					break;

					case 'event_edit':
						$land_option_ary = $geomap->getLandOptions();
						$event_id = request_var('event_id', 0);
						$geo_event = $geomap->getGeoEvents(false, false, 0, $event_id);

						foreach($land_option_ary as $land_id => $land_name)
						{
							$template->assign_block_vars('land_switch', array(
								'LAND_ID'		=> $land_id,
								'LAND_NAME'		=> $land_name,
								'LAND_SELECT'	=> ($land_id == $geo_event['event_land'] ? ' selected="selected"' : ''),
							));
						}

						if ($event_id == 0)
						{
							trigger_error($user->lang['BAD_INPUT'] . adm_back_link($this->u_action . '&amp;action=event_edit&amp;event_id=' . $event_id, E_USER_WARNING));
						}

						$start_day = date('d', $geo_event['event_start']);
						$start_month = date('n', $geo_event['event_start']);
						$start_year = date('Y', $geo_event['event_start']);
						$end_day = date('d', $geo_event['event_end']);
						$end_month = date('n', $geo_event['event_end']);
						$end_year = date('Y', $geo_event['event_end']);

						$template->assign_vars(array(
							'POST_START_DAY'	=> $this->option_list(1, 31, $start_day),
							'POST_START_MONTH'	=> $this->option_list(1, 12, $start_month),
							'POST_START_YEAR'	=> $this->option_list(2008, 2020, $start_year),
							'POST_END_DAY'		=> $this->option_list(1, 31, $end_day),
							'POST_END_MONTH'	=> $this->option_list(1, 12, $end_month),
							'POST_END_YEAR'		=> $this->option_list(2008, 2020, $end_year),
							'EVENT_NAME'		=> $geo_event['event_name'],
							'EVENT_DESC'		=> $geo_event['event_desc'],
							'EVENT_PLZ'			=> $geo_event['event_plz'],
							'EVENT_ORT'			=> $geo_event['event_ort'],
							'S_EVENT_AKTIV'		=> ($geo_event['event_aktiv']) ? true : false,
							'EVENT_URL'			=> $geo_event['event_url'],
							'EVENT_ID'			=> $geo_event['event_id'],
							'TITLE'				=> $user->lang['ACP_GEO_EVENTMGMT'],
							'U_EVENT_EDIT'		=> true,
							'U_BACK'			=> $this->u_action,
							'U_ACTION'			=> $this->u_action . '&amp;action=event_update',
						));
					break;

					case 'event_update':
					// no break;

					case 'event_insert':
						$event_id = request_var('event_id', 0);
						$event_land = request_var('event_land', 1);
						$event_plz = request_var('event_plz', '0');

						if (!check_form_key($form_key))
						{
							trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
						}

						if (!$event_plz || !$event_land || !$geomap->is_plz_string($event_plz))
						{
							if ($action =='event_update')
							{
								trigger_error($user->lang['BAD_INPUT'] . adm_back_link($this->u_action . '&amp;action=event_edit&amp;event_id=' . $event_id, E_USER_WARNING));
							}
							else
							{
								trigger_error($user->lang['BAD_INPUT'] . adm_back_link($this->u_action . '&amp;action=event_add', E_USER_WARNING));
							}
						}

						$sql = 'SELECT laenge, breite, ort FROM ' . GEOMAP_POSTCODE_TABLE . ' WHERE plz = ' . $event_plz . ' AND land = ' . $event_land;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);

						if(!$row)
						{
							if ($action =='event_update')
							{
								trigger_error($user->lang['NO_POSTCODE'] . adm_back_link($this->u_action . '&amp;action=event_edit&amp;event_id=' . $event_id, E_USER_WARNING));
							}
							else
							{
								trigger_error($user->lang['BAD_INPUT'] . adm_back_link($this->u_action . '&amp;action=event_add', E_USER_WARNING));
							}
						}

						$event_ort = utf8_normalize_nfc(request_var('event_ort', '', true));
						if ($event_ort == '') $event_ort = $row['ort'];

						$start_time = gmmktime(0, 0, 0, request_var('start_month', 0), request_var('start_day', 0), request_var('start_year', 0));
						$end_time = gmmktime(0, 0, 0, request_var('end_month', 0), request_var('end_day', 0), request_var('end_year', 0));

						$sql_ary = array(
							'event_name'		=> utf8_normalize_nfc(request_var('event_name', '', true)),
							'event_desc'		=> utf8_normalize_nfc(request_var('event_desc', '', true)),
							'event_plz'			=> $event_plz,
							'event_ort'			=> $event_ort,
							'event_land'		=> $event_land,
							'event_laenge'		=> $row['laenge'],
							'event_breite'		=> $row['breite'],
							'event_start'		=> $start_time,
							'event_end'			=> $end_time,
							'event_aktiv'		=> request_var('event_aktiv', 0),
							'event_url'			=> utf8_normalize_nfc(request_var('event_url', '', true)),
						);

						if ($action =='event_update')
						{
							$db->sql_query('UPDATE ' . GEOMAP_EVENTS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . ' WHERE event_id = ' . $event_id);
						}
						else
						{
							$db->sql_query('INSERT INTO ' . GEOMAP_EVENTS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary));
						}
						trigger_error($user->lang['EVENT_UPDATED'] . adm_back_link($this->u_action));
					break;

					case 'event_delete':
						$event_id = request_var('event_id', 0);
						if (confirm_box(true))
						{
							$sql = 'DELETE FROM ' . GEOMAP_EVENTS_TABLE . ' WHERE event_id = ' . $event_id;
							$db->sql_query($sql);
							trigger_error($user->lang['EVENT_DELETED'] . adm_back_link($this->u_action . '&amp;mode=events'));
						}
						else
						{
							confirm_box(false, $user->lang['EVENT_DELETE_CONFIRM'], build_hidden_fields(array(
								'event_id'	=> $event_id,
								'action'	=> 'event_delete',
							)));
						}

						$geo_events = $geomap->getGeoEvents(false, false, 0, 0, true);
						foreach ($geo_events as $geo_event)
						{
							$template->assign_block_vars('eventsrow', array(
								'EVENT_LOCATION'	=> $geo_event['event_plz'] . ' ' . $geo_event['event_ort'],
								'EVENT_NAME'		=> $geo_event['event_name'],
								'EVENT_START'		=> $user->format_date($geo_event['event_start'], "d.m.Y"),
								'EVENT_END'			=> $user->format_date($geo_event['event_end'], "d.m.Y"),
								'S_EVENT_START'		=> ($geo_event['event_start'] < time()) ? true : false,
								'S_EVENT_END'		=> ($geo_event['event_end'] > time()) ? true : false,
								'S_EVENT_AKTIV'		=> ($geo_event['event_aktiv']) ? true : false,
								'DE_ACTIVATE'		=> $this->u_action . '&amp;action=event_deac&amp;event_id=' . $geo_event['event_id'],
								'U_EVENTEDIT'		=> $this->u_action . '&amp;action=event_edit&amp;event_id=' . $geo_event['event_id'],
								'U_EVENTDEL'		=> $this->u_action . '&amp;action=event_delete&amp;event_id=' . $geo_event['event_id'],
							));
						}

						$template->assign_vars(array(
							'TITLE'				=> $user->lang['ACP_GEO_EVENTMGMT'],
							'TITLE_DESC'		=> $user->lang['ACP_GEO_EVENTMGMT_DESC'],
							'U_NEW_EVENT'		=> $this->u_action . '&amp;action=event_add',
							'U_EVENTS'			=> true,
						));
					break;

					case 'event_deac':

						$event_id = request_var('event_id', 0);

						$result = $db->sql_query('SELECT event_aktiv FROM ' . GEOMAP_EVENTS_TABLE . '
								WHERE event_id = ' . $event_id);

						$aktiv_value = ($db->sql_fetchfield('event_aktiv') == 0 ? 1 : 0);
						$db->sql_freeresult($result);

						$db->sql_query('UPDATE ' . GEOMAP_EVENTS_TABLE . '
							SET event_aktiv = ' . $aktiv_value . '
							WHERE event_id = ' . $event_id);

					// no break;
					default:
						$geo_events = $geomap->getGeoEvents(false, false, 0, 0, true);

						foreach ($geo_events as $geo_event)
						{
							$template->assign_block_vars('eventsrow', array(
								'EVENT_LOCATION'	=> $geo_event['event_plz'] . ' ' . $geo_event['event_ort'],
								'EVENT_NAME'		=> $geo_event['event_name'],
								'EVENT_START'		=> $user->format_date($geo_event['event_start'], "d.m.Y"),
								'EVENT_END'			=> $user->format_date($geo_event['event_end'], "d.m.Y"),
								'S_EVENT_START'		=> ($geo_event['event_start'] < time()) ? true : false,
								'S_EVENT_END'		=> ($geo_event['event_end'] > time()) ? true : false,
								'S_EVENT_AKTIV'		=> ($geo_event['event_aktiv']) ? true : false,
								'DE_ACTIVATE'		=> $this->u_action . '&amp;action=event_deac&amp;event_id=' . $geo_event['event_id'],
								'U_EVENTEDIT'		=> $this->u_action . '&amp;action=event_edit&amp;event_id=' . $geo_event['event_id'],
								'U_EVENTDEL'		=> $this->u_action . '&amp;action=event_delete&amp;event_id=' . $geo_event['event_id'],
							));
						}

						$template->assign_vars(array(
							'TITLE'				=> $user->lang['ACP_GEO_EVENTMGMT'],
							'TITLE_DESC'		=> $user->lang['ACP_GEO_EVENTMGMT_DESC'],
							'U_NEW_EVENT'		=> $this->u_action . '&amp;action=event_add',
							'U_EVENTS'			=> true,
						));
					break;
				}
			break;

			case 'user_management':
				$this->page_title = 'ACP_GEO_USRMGMT';
				$land_option_ary = $geomap->getLandOptions();

				switch($action)
				{
					case 'add':
						$template->assign_vars(array(
							'U_ADD'			=> true,
							'U_ACTION'		=> $this->u_action . '&amp;action=insert',
							'U_BACK'		=> $this->u_action,
						));

						foreach($land_option_ary as $land_id => $land_name)
						{
							$template->assign_block_vars('land_switch', array(
								'LAND_ID'	=> $land_id,
								'LAND_NAME'	=> $land_name,
							));
						}

						// select users not in map
						$sql = 'SELECT t1.user_id, t1.username
							FROM ' . USERS_TABLE . ' t1
							LEFT JOIN ' . PROFILE_FIELDS_DATA_TABLE . ' t2 ON t1.user_id = t2.user_id
							WHERE t2.pf_plz IS NULL
							AND t1.user_type <> 2
							ORDER BY t1.username';

						$result = $db->sql_query($sql);

						while ($row = $db->sql_fetchrow($result))
						{
							$template->assign_block_vars('user_switch', array(
								'USER_ID'	=> $row['user_id'],
								'USER_NAME'	=> $row['username'],
							));
						}
						$db->sql_freeresult($result);
					break;

					case 'edit':
						$sql = 'SELECT t1.user_id , t2.username , t1.pf_plz , t1.pf_land
							FROM ' . PROFILE_FIELDS_DATA_TABLE . ' t1
							INNER JOIN ' . USERS_TABLE . ' t2 ON t1.user_id = t2.user_id
							WHERE t1.user_id = ' . request_var('id', 0);
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);

						$template->assign_vars(array(
							'USER_NAME'		=> $row['username'],
							'POSTCODE'		=> $row['pf_plz'],
							'U_EDIT'		=> true,
							'USER_ID'		=> $row['user_id'],
							'U_BACK'		=> $this->u_action,
							'U_ACTION'		=> $this->u_action . '&amp;action=update',
						));
						$user_land_id = $row['pf_land'];
						$db->sql_freeresult($result);

						foreach($land_option_ary as $land_id => $land_name)
						{
							$template->assign_block_vars('land_switch', array(
								'LAND_ID'		=> $land_id,
								'LAND_NAME'		=> $land_name,
								'LAND_SELECT'	=> ($land_id == $user_land_id ? ' selected="selected"' : ''),
							));
						}
					break;

					case 'update':
					// no break;
					case 'insert':
						$post_plz = request_var('postcode', '');
						$post_land = request_var('land', 0);

						if (!check_form_key($form_key))
						{
							trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
						}

						if (!$post_plz || !$post_land || !$geomap->is_plz_string($post_plz))
						{
							trigger_error($user->lang['BAD_INPUT'] . adm_back_link($this->u_action . '&amp;action=edit&amp;id=' . request_var('id', 0), E_USER_WARNING));
						}

						$result = $db->sql_query('SELECT COUNT(plzid) as plz_count FROM ' . GEOMAP_POSTCODE_TABLE . '
								WHERE plz = ' . $post_plz . '
								AND land = ' . $post_land);
						$plz_exists = ($db->sql_fetchfield('plz_count') == 0 ? false : true);
						$db->sql_freeresult($result);

						if(!$plz_exists) 
						{
							trigger_error($user->lang['NO_POSTCODE'] . adm_back_link($this->u_action . '&amp;action=user_mgmt', E_USER_WARNING));
						}
						else
						{
							$sql_ary = array(
								'pf_plz'	=> $post_plz,
								'pf_land'	=> $post_land,
							);

							$result = $db->sql_query('SELECT COUNT(user_id) AS user_count FROM ' . PROFILE_FIELDS_DATA_TABLE . '
									WHERE user_id = ' . request_var('id', 0));
							$user_exist = ($db->sql_fetchfield('user_count') == 0 ? false : true);
							$db->sql_freeresult($result);

							if ($user_exist)
							{
								$db->sql_query('UPDATE ' . PROFILE_FIELDS_DATA_TABLE . '
									SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
									WHERE user_id = ' . request_var('id', 0));
							}
							else
							{
								$sql_ary['user_id'] = request_var('id', 0);
								$db->sql_query('INSERT INTO ' . PROFILE_FIELDS_DATA_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary));
							}

							$action_msg = ($action == 'update' ? $user->lang['USER_UPDATED'] : $user->lang['USER_INSERTED']);
							trigger_error($action_msg . adm_back_link($this->u_action . '&amp;action=user_mgmt'));
						}
					break;

					// delete user
					case 'delete':
						$geo_user_id = request_var('id', 0);
						if (confirm_box(true))
						{
							$sql = 'UPDATE ' . PROFILE_FIELDS_DATA_TABLE . '
								SET pf_plz = NULL, pf_land = NULL
								WHERE user_id = ' . $geo_user_id;
							$db->sql_query($sql);
							trigger_error($user->lang['USER_DELETED'] . adm_back_link($this->u_action . '&amp;action=user_mgmt'));
						}
						else
						{
							confirm_box(false, $user->lang['REALY_DELETE'], build_hidden_fields(array(
								'id'		=> $geo_user_id,
								'action'	=> 'delete',
							)));
						}
					//no break;

					default:
						$start = request_var('start', 0);
						$sort_order = request_var('sort', 'username');

						$geousers = $geomap->getGeoUsers('all');
						$geousers = $geomap->sort_ary_by_field($geousers, $sort_order);

						$geousers_count = count($geousers);
						$geousers = array_slice($geousers, $start, $config['posts_per_page']);

						foreach ($geousers as $geouser)
						{
							$template->assign_block_vars('user_in_map', array(
								'NAME'				=> $geouser['username'],
								'POSTCODE'			=> $geouser['pf_plz'],
								'LAND'				=> $land_option_ary[$geouser['pf_land']],
								'U_USEREDIT'		=> $this->u_action . '&amp;action=edit&amp;id=' . $geouser['user_id'],
								'U_USERDEL'			=> $this->u_action . '&amp;action=delete&amp;id=' . $geouser['user_id'],
							));
						}

						$template->assign_vars(array(
							'TITLE'				=> $user->lang['ACP_GEO_USRMGMT'],
							'TITLE_DESC'		=> $user->lang['ACP_GEO_USRMGMT_DESC'],
							'U_MGMT'			=> true,
							'U_ACTION_NEW'		=> $this->u_action . '&amp;action=add',
							'U_SORT_NAME'		=> $this->u_action . '&amp;sort=username',
							'U_SORT_PLZ'		=> $this->u_action . '&amp;sort=pf_plz',
							'U_SORT_LAND'		=> $this->u_action . '&amp;sort=pf_land',
							'SORT_ORDER'		=> ($sort_order == 'pf_land' ? 3 : ($sort_order == 'pf_plz' ? 2 : 1)),
							'S_ON_PAGE'			=> on_page($geousers_count, $config['posts_per_page'], $start),
							'PAGINATION'		=> generate_pagination($this->u_action . '&amp;sort=' . $sort_order, $geousers_count, $config['posts_per_page'], $start, true),
							'USER_COUNT'		=> $geousers_count,
						));
					break;
				}
			break;

			case 'recreate_map':
				if ($action == 'create_map')
				{
					$geomap->createGeomap();
					trigger_error($user->lang['MAP_CREATED'] . adm_back_link($this->u_action));
				}

				$this->page_title = 'ACP_GEO_RECREATE';
				$template->assign_vars(array(
					'U_ACTION'			=> $this->u_action . '&amp;action=create_map',
					'U_RECREATE'		=> true,
				));
			break;

			case 'plz_management':
				$land_option_ary = $geomap->getLandOptions();
				$this->page_title = 'ACP_GEO_PLZMGMT';

				switch($action)
				{
					case 'new_plz':
						foreach($land_option_ary as $land_id => $land_name)
						{
							$template->assign_block_vars('land_switch', array(
								'LAND_ID'		=> $land_id,
								'LAND_NAME'		=> $land_name,
							));
						}

						$template->assign_vars(array(
							'TITLE'				=> $user->lang['ACP_GEO_PLZMGMT'],
							'U_ACTION'			=> $this->u_action . '&amp;action=insert_plz',
							'U_BACK'			=> $this->u_action,
							'U_PLZ_EDIT'		=> true,
						));
					break;

					case 'search_plz':
						$plz_plz = request_var('plz_plz', '');
						$plz_land = request_var('plz_land', 0);

						if (!$plz_plz || !$plz_land || !$geomap->is_plz_string($plz_plz))
						{
							trigger_error($user->lang['BAD_INPUT'] . adm_back_link($this->u_action, E_USER_WARNING));
						}

						$result = $db->sql_query('SELECT COUNT(plzid) as plz_count FROM ' . GEOMAP_POSTCODE_TABLE . '
								WHERE plz = ' . $plz_plz . '
								AND land = ' . $plz_land);
						$plz_exists = ($db->sql_fetchfield('plz_count') == 0 ? false : true);
						$db->sql_freeresult($result);

						if(!$plz_exists) 
						{
							trigger_error($user->lang['NO_POSTCODE'] . adm_back_link($this->u_action, E_USER_WARNING));
						}
						else
						{
							$result = $db->sql_query('SELECT * FROM ' . GEOMAP_POSTCODE_TABLE . '
								WHERE plz = ' . $plz_plz . '
								AND land = ' . $plz_land);

							$row = $db->sql_fetchrow($result);
							$db->sql_freeresult($result);

							foreach($land_option_ary as $land_id => $land_name)
							{
								$template->assign_block_vars('land_switch', array(
									'LAND_ID'		=> $land_id,
									'LAND_NAME'		=> $land_name,
									'LAND_SELECT'	=> ($land_id == $plz_land ? ' selected="selected"' : ''),
								));
							}

							$template->assign_vars(array(
								'TITLE'				=> $user->lang['ACP_GEO_PLZMGMT'],
								'PLZ_PLZ'			=> $row['plz'],
								'PLZ_ORT'			=> $row['ort'],
								'PLZ_LAENGE'		=> $row['laenge'],
								'PLZ_BREITE'		=> $row['breite'],
								'PLZ_ID'			=> $row['plzid'],
								'U_ACTION'			=> $this->u_action . '&amp;action=update_plz',
								'U_BACK'			=> $this->u_action,
								'U_PLZ_EDIT'		=> true,
								'U_PLZ_DELETE'		=> $this->u_action . '&amp;action=delete_plz&amp;plz_id=' . $row['plzid'],
							));
						}
					break;

					case 'delete_plz':
						$plzid = request_var('plz_id', 0);
						if (confirm_box(true))
						{
							$sql = 'DELETE FROM ' . GEOMAP_POSTCODE_TABLE . ' WHERE plzid = ' . $plzid;
							$db->sql_query($sql);
							trigger_error($user->lang['PLZ_DELETED'] . adm_back_link($this->u_action . '&amp;action=user_mgmt'));
						}
						else
						{
							confirm_box(false, $user->lang['PLZ_DELETE_CONFIRM'], build_hidden_fields(array(
								'plz_id'	=> $plzid,
								'action'	=> 'delete_plz',
								'mode'		=> 'plz_management',
							)));
						}

						foreach($land_option_ary as $land_id => $land_name)
						{
							$template->assign_block_vars('land_switch', array(
								'LAND_ID'		=> $land_id,
								'LAND_NAME'		=> $land_name,
							));
						}

						$template->assign_vars(array(
							'TITLE'				=> $user->lang['ACP_GEO_PLZMGMT'],
							'U_ACTION_SEARCH'	=> $this->u_action . '&amp;action=search_plz',
							'U_ACTION_NEW'		=> $this->u_action . '&amp;action=new_plz',
							'U_PLZ_MGMT'		=> true,
						));
					break;

					case 'update_plz':
						if (!check_form_key($form_key))
						{
							trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
						}

						$plz_plz = request_var('plz_plz', '');
						$plz_land = request_var('plz_land', 0);
						$plzid = request_var('plz_id', 0);
						$plz_laenge = str_replace(',','.', request_var('plz_laenge', '0'));
						$plz_breite = str_replace(',','.', request_var('plz_breite', '0'));
						$plz_ort = utf8_normalize_nfc(request_var('plz_ort', '', true));

						if (!$plz_plz || !$plz_land || !$geomap->is_plz_string($plz_plz) || !is_numeric($plz_land) || !is_numeric($plz_laenge) || !is_numeric($plz_breite) || $plz_ort == '')
						{
							trigger_error($user->lang['BAD_INPUT'] . adm_back_link($this->u_action, E_USER_WARNING));
						}

						$sql_ary = array(
							'plz'		=> $plz_plz,
							'land'		=> $plz_land,
							'laenge'	=> $plz_laenge,
							'breite'	=> $plz_breite,
							'ort'		=> $plz_ort,
						);

						$db->sql_query('UPDATE ' . GEOMAP_POSTCODE_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . ' WHERE plzid = ' . $plzid);
						trigger_error($user->lang['PLZ_UPDATED'] . adm_back_link($this->u_action));
					break;

					case 'insert_plz':
						if (!check_form_key($form_key))
						{
							trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
						}

						$plz_plz = request_var('plz_plz', '');
						$plz_land = request_var('plz_land', 0);
						$plzid = request_var('plz_id', 0);
						$plz_laenge = str_replace(',','.', request_var('plz_laenge', '0'));
						$plz_breite = str_replace(',','.', request_var('plz_breite', '0'));
						$plz_ort = utf8_normalize_nfc(request_var('plz_ort', '', true));

						if (!$plz_plz || !$plz_land || !$geomap->is_plz_string($plz_plz) || !is_numeric($plz_land) || !is_numeric($plz_laenge) || !is_numeric($plz_breite) || !$plz_ort)
						{
							trigger_error($user->lang['BAD_INPUT'] . adm_back_link($this->u_action . '&amp;action=new_plz', E_USER_WARNING));
						}

						$result = $db->sql_query('SELECT COUNT(plzid) as plz_count FROM ' . GEOMAP_POSTCODE_TABLE . '
								WHERE plz = ' . $plz_plz . '
								AND land = ' . $plz_land);
						$plz_exists = ($db->sql_fetchfield('plz_count') == 0 ? false : true);
						$db->sql_freeresult($result);

						if($plz_exists) 
						{
							trigger_error($user->lang['POSTCODE_ALREADY_EXISTS'] . adm_back_link($this->u_action, E_USER_WARNING));
						}
						else
						{
							$sql_ary = array(
								'plz'		=> $plz_plz,
								'land'		=> $plz_land,
								'laenge'	=> $plz_laenge,
								'breite'	=> $plz_breite,
								'ort'		=> $plz_ort,
							);

							$db->sql_query('INSERT INTO ' . GEOMAP_POSTCODE_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary));
							trigger_error($user->lang['PLZ_INSERTED'] . adm_back_link($this->u_action));
						}
					break;

					default:
						foreach($land_option_ary as $land_id => $land_name)
						{
							$template->assign_block_vars('land_switch', array(
								'LAND_ID'		=> $land_id,
								'LAND_NAME'		=> $land_name,
							));
						}

						$template->assign_vars(array(
							'TITLE'				=> $user->lang['ACP_GEO_PLZMGMT'],
							'U_ACTION_SEARCH'	=> $this->u_action . '&amp;action=search_plz',
							'U_ACTION_NEW'		=> $this->u_action . '&amp;action=new_plz',
							'U_PLZ_MGMT'		=> true,
						));
					break;
				}
			break;
		}
	}

	function option_list($start, $end, $selected = 0)
	{
		$option = '';
		for($i = $start; $i <= $end; $i++)
		{
			$option .= ($i == $selected) ? '<option selected="selected" >' . sprintf ("%02d", $i) . '</option>' : '<option>' .  sprintf ("%02d", $i) . '</option>';
		}
		return $option;
	}
}
?>