<?php
/**
*
* @package - GeoMap
* @version $Id: geomap.php 25 2010-12-01 14:40:21Z Frank Wiesemann $
* @copyright (c) Frank Wiesemann ( http://webmasterarena.net/ )
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* DO NOT CHANGE
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine

/**
* NOTE: Most of the language items are used in javascript
* If you want to use quotes or other chars that need escaped, be sure you escape them double
*/
$lang = array_merge($lang, array(
	'ACP_GEOMAP'				=> 'GeoMap',
	'ACP_GEO_SETTINGS'			=> 'Einstellungen',
	'ACP_GEO_SETTINGS_DESC'		=> 'Hier kannst du die Einstellungen deiner GeoMap ändern',
	'ACP_GEO_SAVE_SETTINGS'		=> 'Einstellungen speichern',
	'ACP_GEO_USRMGMT'			=> 'Benutzerverwaltung',
	'ACP_GEO_USRMGMT_DESC'		=> 'Hier kannst du die Benutzer deiner GeoMap verwalten.',
	'ACP_GEO_RECREATE'			=> 'Karte neu zeichnen',
	'ACP_GEO_RECREATE_DESC'		=> 'Zeichnet alle Punkte auf der Karte neu.',
	'ACP_GEO_GRPMGMT'			=> 'Gruppenverwaltung',
	'ACP_GEO_GRPMGMT_DESC'		=> 'Hier kannst du festlegen, welche Gruppen auf der GeoMap versteckt werden sollen. User aus versteckten Gruppen werden auch in der GeoMap Suche nicht gefunden.',
	'ACP_GEO_GROUPS'			=> 'Gruppen auf der GeoMap',
	'ACP_GEO_EVENTMGMT'			=> 'Ereignisverwaltung',
	'ACP_GEO_EVENTMGMT_DESC'	=> 'Hier kannst du die Ereignisse verwalten, die auf der Geomap angezeigt werden sollen.<br />Ereignisse werden erst ab dem Startdatum angezeigt. Bei erreichen des Enddatums, wird das Ereignis wieder ausgeblendet.',
	'ACP_GEO_PLZMGMT'			=> 'Postleitzahlen verwalten',
	'ACP_GEO_PLZMGMT_DESC'		=> 'Suche nach Postleitzahlen in der GeoMap um sie zu bearbeiten bzw. zu löschen, oder füge neue Postleitzahlen hinzu.',
	'SEARCH_PLZ'				=> 'Postleitzahl suchen',
	'NEW_PLZ'					=> 'Neue Postleitzahl',
	'NEW_PLZ_DESC'				=> 'Füge eine neue Postleitzahl hinzu.',
	'BREITE'					=> 'Breite',
	'BREITE_DESC'				=> 'Gibt die geografische Breite (Latitude) der Postleitzahl in Dezimalschreibweise (z.B. 49.6767) an.',
	'LAENGE'					=> 'Länge',
	'LAENGE_DESC'				=> 'Gibt die geografische Länge (Longitude) der Postleitzahl in Dezimalschreibweise (z.B. 8.5483) an.',

	'INACTIVE_TEXT'				=> 'Deaktivierungstext',
	'INACTIVE_TEXT_DESC'		=> 'Dieser Text wird angezeigt wenn die GeoMap deaktiviert ist.',
	'ACTIVATE_MAP'				=> 'Karte aktivieren',
	'ACTIVATE_EVENTS'			=> 'Ereignisse aktivieren',
	'ACTIVATE_EVENT'			=> 'Ereignis aktivieren',
	'ADMIN_POINT'				=> 'Admin Punkte',
	'ADMIN_POINT_DESC'			=> 'Hier kannst du die Größe der Adminpunkte auf der Karte festlegen.',
	'MOD_POINT'					=> 'Moderator Punkte',
	'MOD_POINT_DESC'			=> 'Hier kannst du die Größe der Moderatorpunkte auf der Karte festlegen.',
	'USER_POINT'				=> 'Benutzer Punkte',
	'USER_POINT_DESC'			=> 'Hier kannst du die Größe der Benutzerpunkte auf der Karte festlegen.',
	'EVENT_POINT'				=> 'Ereignis Punkte',
	'EVENT_POINT_DESC'			=> 'Hier kannst du die Größe der Ereignispunkte auf der Karte festlegen.',
	'SHOW_EVENT'				=> 'Ereignisse anzeigen',
	'SHOW_EVENT_DESC'			=> 'Legt fest ob die von dir festgelegten Ereignisse (Events) auf der Karte angezeigt werden sollen.',
	'DEFAULT_COLOUR'			=> 'Standardfarbe',
	'DEFAULT_COLOUR_DESC'		=> 'Standardfarbe für Gruppen denen keine Farbe zugewiesen wurde.',
	'EVENT_COLOR'				=> 'Ereignisfarbe',
	'EVENT_COLOR_DESC'			=> 'Legt die Farbe fest, mit der Ereignisse auf die Karte gezeichnet werden.',
	'PIXEL'						=> 'Größe der Punkte in Pixel (min. 6)',
	'NAME'						=> 'Benutzername',
	'POSTCODE'					=> 'Postleitzahl',
	'LAND'						=> 'Land',
	'UPDATED'					=> 'Die Einstellungen deiner GeoMap wurden erfolgreich geändert',
	'NEW'						=> 'Neuer Benutzer',
	'USER_UPDATED'				=> 'Die Benutzerdaten wurden erfolgreich geändert',
	'USER_INSERTED'				=> 'Der Benutzer wurde hinzugefügt',
	'USER_DELETED'				=> 'Der Benutzer wurde gelöscht',
	'REALY_DELETE'				=> 'Soll der Benutzer wirklich gelöscht werden?<br />(Der Benutzer wird nur aus der Karte gelöscht, nicht aus dem Forum.)',
	'REFRESH_INTERVAL'			=> 'Kartenerstellungsintervall',
	'REFRESH_INTERVAL_DESC'		=> 'Hier kannst du festlegen nach welchem Zeitraum die GeoMap neu gezeichnet wird um z.B. neue User zu erfassen.<br />Um die Karte bei jedem Aufruf neu zu zeichnen, trage 0 ein. (Dies verlangsamt die GeoMap deutlich!)',
	'REFRESH_INTERVAL_UNIT'		=> 'Intervallangabe in Stunden',
	'REQUIRE'					=> 'Eintragung erzwingen',
	'REQUIRE_DESC'				=> 'Hiermit kannst du das Eintragen des Benutzers in die Geomap bei Neuregistrierungen erzwingen.',
	'NO_POSTCODE'				=> 'Die Postleitzahl wurde nicht gefunden!',
	'GEO_EVENTS'				=> 'Ereignisse',
	'GEO_EVENT'					=> 'Ereignis',
	'MAP_CREATED'				=> 'Die GeoMap wurde neu gezeichnet.',
	'MAIN_SETTINGS'				=> 'Allgemeine Einstellungen',
	'EVENT_SETTINGS'			=> 'Ereignis Einstellungen',
	'COLOR_SIZE_SETTINGS'		=> 'Einstellungen der Farben und Größen',
	'EVENT_START'				=> 'Ereignis beginnt',
	'EVENT_START_DESC'			=> 'Zeitpunkt ab dem das Ereignis angezeigt werden soll.',
	'EVENT_END'					=> 'Ereignis endet',
	'EVENT_END_DESC'			=> 'Zeitpunkt nach dem das Ereignis nicht mehr angezeigt werden soll.',
	'EVENT_LOCATION'			=> 'Ort',
	'EVENT_NAME'				=> 'Ereignisname',
	'EVENT_NAME_DESC'			=> 'Gib einen Namen für das Ereignis ein.',
	'EVENT_DESC'				=> 'Ereignisbeschreibung',
	'EVENT_DESC_DESC'			=> 'Beschreibung für das Ereignis',
	'EVENT_ORT'					=> 'Ereignisort',
	'EVENT_ORT_DESC'			=> 'Trage den Ort des Ereignisses ein. Wenn du ihn leer läßt, wird der Ort aus der Postleitzahlentabelle genommen.',
	'EVENT_URL'					=> 'Ereignislink',
	'EVENT_URL_DESC'			=> 'Hier kannst du einen Link zum Ereignis einragen.',
	'EVENT_UPDATED'				=> 'Das Ereignis wurde gespeichert.',
	'EVENT_DELETED'				=> 'Das Ereignis wurde gelöscht.',
	'EVENT_DELETE_CONFIRM'		=> 'Soll das Ereignis gelöscht werden?',
	'NEW_EVENT'					=> 'Neues Ereignis',
	'BAD_INPUT'					=> 'Du hast einen fehlerhaften Wert eingegeben.',
	'POSTCODE_ALREADY_EXISTS'	=> 'Die Postleitzahl existiert bereits in der Datenbank.',
	'PLZ_INSERTED'				=> 'Die Postleitzahl wurde hinzugefügt.',
	'PLZ_UPDATED'				=> 'Die Postleitzahl wurde gespeichert.',
	'PLZ_DELETED'				=> 'Die Postleitzahl wurde gelöscht.',
	'PLZ_DELETE_CONFIRM'		=> 'Soll die Postleitzahl gelöscht werden?',
));
?>
