<?php
/**
*
* @package - GeoMap
* @version $Id: geomap.php 25 2010-12-01 14:40:21Z Frank Wiesemann $
* @copyright (c) Frank Wiesemann ( http://webmasterarena.net/ )
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* DO NOT CHANGE
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine

/**
* NOTE: Most of the language items are used in javascript
* If you want to use quotes or other chars that need escaped, be sure you escape them double
*/
$lang = array_merge($lang, array(
	'ACP_GEOMAP'				=> 'GeoMap',
	'ACP_GEO_SETTINGS'			=> 'Settings',
	'ACP_GEO_SETTINGS_DESC'		=> 'Here you can change the settings of the GeoMap.',
	'ACP_GEO_SAVE_SETTINGS'		=> 'Save settings',
	'ACP_GEO_USRMGMT'			=> 'User management',
	'ACP_GEO_USRMGMT_DESC'		=> 'Here you can manage the Geomap users .',
	'ACP_GEO_RECREATE'			=> 'Recreate map',
	'ACP_GEO_RECREATE_DESC'		=> 'Recreates the points on the GeoMap.',
	'ACP_GEO_GRPMGMT'			=> 'Group management',
	'ACP_GEO_GRPMGMT_DESC'		=> 'Here you can hide groups from GeoMap. User of a hidden group will not be found at the GeoMap search.',
	'ACP_GEO_GROUPS'			=> 'Groups on GeoMap',
	'ACP_GEO_EVENTMGMT'			=> 'Event management',
	'ACP_GEO_EVENTMGMT_DESC'	=> 'Here you can manage the events, that has to be shown on map.<br />Events only shown after start date. On reaching the end date, the event will be shown anymore.',
	'ACP_GEO_PLZMGMT'			=> 'Manage postcodes',
	'ACP_GEO_PLZMGMT_DESC'		=> 'Search for postcodes to manage or delete them, or add a new postcode.',
	'SEARCH_PLZ'				=> 'Search postcode',
	'NEW_PLZ'					=> 'New postcode',
	'NEW_PLZ_DESC'				=> 'Add a new postcode.',
	'BREITE'					=> 'Latitude',
	'BREITE_DESC'				=> 'Insert the latitude (eg. 49.6767) of the postcode.',
	'LAENGE'					=> 'Longitude',
	'LAENGE_DESC'				=> 'Insert the Longitude (eg. 8.5483) of the postcode.',

	'INACTIVE_TEXT'				=> 'Inactive message',
	'INACTIVE_TEXT_DESC'		=> 'This message will show if your map is inactive.',
	'ACTIVATE_MAP'				=> 'Map is active',
	'ACTIVATE_EVENTS'			=> 'Activate events',
	'ACTIVATE_EVENT'			=> 'Activate event',
	'ADMIN_POINT'				=> 'Admin points on map',
	'ADMIN_POINT_DESC'			=> 'Here you can set the size of the admin points on map.',
	'MOD_POINT'					=> 'Moderator points',
	'MOD_POINT_DESC'			=> 'Here you can set the size of the moderator points on map.',
	'USER_POINT'				=> 'User points',
	'USER_POINT_DESC'			=> 'Here you can set the size of the user points on map.',
	'EVENT_POINT'				=> 'Event points',
	'EVENT_POINT_DESC'			=> 'Here you can set the size of the event points on map.',
	'SHOW_EVENT'				=> 'Show events',
	'SHOW_EVENT_DESC'			=> 'Defines that events have to be shown on map.',
	'DEFAULT_COLOUR'			=> 'Default color',
	'DEFAULT_COLOUR_DESC'		=> 'Default color for groups whitout a colour setting.',
	'EVENT_COLOR'				=> 'Event color',
	'EVENT_COLOR_DESC'			=> 'Defines the color for events that shown on map.',
	'PIXEL'						=> 'size of the points in pixel (minimum size: 6)',
	'NAME'						=> 'Username',
	'POSTCODE'					=> 'Postcode',
	'LAND'						=> 'Land',
	'UPDATED'					=> 'Settings successfully changed',
	'NEW'						=> 'New User',
	'USER_UPDATED'				=> 'User settings successfully changed',
	'USER_INSERTED'				=> 'User added succsessfully',
	'USER_DELETED'				=> 'User deleted',
	'REALY_DELETE'				=> 'Are you sure to delete this user?<br />(the user will only delete from map, not from your board.)',
	'REFRESH_INTERVAL'			=> 'Map refresh time',
	'REFRESH_INTERVAL_DESC'		=> 'Time before your map gets updated in hour.<br />To update your map continuously, insert 0. (This makes the GeoMap very slow!)',
	'REFRESH_INTERVAL_UNIT'		=> 'Refresh time in hour',
	'REQUIRE'					=> 'Enforce to map',
	'REQUIRE_DESC'				=> 'You can enforce new member to map on GeoMap at registration.',
	'NO_POSTCODE'				=> 'Postcode not found!',
	'HIDDEN'					=> 'Hidden',
	'GEO_EVENTS'				=> 'Events',
	'GEO_EVENT'					=> 'Event',
	'MAP_CREATED'				=> 'The GeoMap was recreated.',
	'MAIN_SETTINGS'				=> 'Main settings',
	'EVENT_SETTINGS'			=> 'Event settings',
	'COLOR_SIZE_SETTINGS'		=> 'Color and size settings',
	'EVENT_START'				=> 'Event starts',
	'EVENT_START_DESC'			=> 'The begin of displaying this event.',
	'EVENT_END'					=> 'Event ends',
	'EVENT_END_DESC'			=> 'On reaching this date, the event will be shown anymore.',
	'EVENT_LOCATION'			=> 'Location',
	'EVENT_NAME'				=> 'Event name',
	'EVENT_NAME_DESC'			=> 'Gives the event a name.',
	'EVENT_DESC'				=> 'Event description',
	'EVENT_DESC_DESC'			=> 'Description for the event.',
	'EVENT_ORT'					=> 'Event location',
	'EVENT_ORT_DESC'			=> 'Insert the location of the event. If blank, GeoMap uses the location from postcode table.',
	'EVENT_URL'					=> 'Event url',
	'EVENT_URL_DESC'			=> 'Here you can insert an url for the event.',
	'EVENT_UPDATED'				=> 'The event was saved.',
	'EVENT_DELETED'				=> 'The event was deleted.',
	'EVENT_DELETE_CONFIRM'		=> 'Are you sure you want to delete this event?',
	'NEW_EVENT'					=> 'New event',
	'BAD_INPUT'					=> 'Wrong input',
	'POSTCODE_ALREADY_EXISTS'	=> 'This postcode already exists in database.',
	'PLZ_INSERTED'				=> 'The postcode was inserted.',
	'PLZ_UPDATED'				=> 'The postcode was updated.',
	'PLZ_DELETED'				=> 'The postcode was deleted.',
	'PLZ_DELETE_CONFIRM'		=> 'Are you sure you want to delete this postcode?',
));
?>
